﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ExemploCSharp
{
    class TP650
    {
        public List<byte> codEAN13(string cod)
        {
            List<byte> b = new List<byte>();
            b.Add(0x1d);
            b.Add(0x6b);
            b.Add(0x02);
            b.AddRange(Encoding.ASCII.GetBytes(cod));
            b.Add(0x00);
            return b;
        }

        public List<byte> codEAN8(String cod)
        {
            List<byte> b = new List<byte>();
            b.Add(0x1d);
            b.Add(0x6b);
            b.Add(0x03);
            b.AddRange(Encoding.ASCII.GetBytes(cod));
            b.Add(0x00);
            return b;
        }

        public List<byte> codUPCA(String cod)
        {
            List<byte> b = new List<byte>();
            b.Add(0x1d);
            b.Add(0x6b);
            b.Add(0x00);
            b.AddRange(Encoding.ASCII.GetBytes(cod));
            b.Add(0x00);
            return b;
        }

        public List<byte> cod128(String cod)
        {
            List<byte> b = new List<byte>();
            b.Add(0x1d);
            b.Add(0x6b);
            b.Add(0x49);
            b.Add((byte)(cod.Length + 2));
            b.AddRange(Encoding.ASCII.GetBytes(cod));
            return b;
        }

        public List<byte> alturaCodBarras(int altura)
        {
            List<byte> b = new List<byte>();
            b.Add(0x1d);
            b.Add(0x68);
            b.Add((byte)altura);
            return b;
        }

        public List<byte> textoNegrito(String texto)
        {
            List<byte> b = new List<byte>();
            b.Add(0x1b);
            b.Add(0x21);
            b.Add(0x00);
            b.Add(0x1b);
            b.Add(0x47);
            b.Add((byte)0xff);
            b.AddRange(Encoding.ASCII.GetBytes(texto));
            b.Add(0x1b);
            b.Add(0x47);
            b.Add(0x00);
            return b;
        }

        public List<byte> textoCondensado(String texto)
        {
            List<byte> b = new List<byte>();
            b.Add(0x1b);
            b.Add(0x21);
            b.Add(0x00);
            b.Add(0x1b);
            b.Add(0x4d);
            b.Add(0x01);
            b.AddRange(Encoding.ASCII.GetBytes(texto));
            b.Add(0x1b);
            b.Add(0x4d);
            b.Add(0x00);
            return b;
        }

        public List<byte> cortePapel()
        {
            return new List<byte>(new byte[] { 0x1b, 0x6d });
        }

        public List<byte> abreGaveta(int pino, int pulso)
        {
            List<byte> b = new List<byte>();
            b.Add(0x10);
            b.Add(0x14);
            b.Add(0x01);
            b.Add((byte)pino);
            b.Add((byte)pulso);
            return b;
        }

        public List<byte> qrcode(int size, String data)
        {
            int l = data.Length + 3;
            List<byte> b = new List<byte>();
            //function 65 - mode
            b.AddRange(new byte[] { 0x1d, 0x28, 0x6b, 0x04, 0x00, 0x31, 0x41, 0x32, 0x00 });
            //function 67 - size
            b.AddRange(new byte[] { 0x1d, 0x28, 0x6b, 0x03, 0x00, 0x31, 0x43 });
            b.Add((byte)size);
            //function 80 - save data        
            b.Add(0x1d);
            b.Add(0x28);
            b.Add(0x6b);
            b.Add((byte)(l % 256));
            b.Add((byte)(l / 256));
            b.Add(0x31);
            b.Add(0x50);
            b.Add(0x30);
            b.AddRange(Encoding.ASCII.GetBytes(data));
            //function 81 - print data
            b.AddRange(new byte[] { 0x1d, 0x28, 0x6b, 0x03, 0x00, 0x31, 0x51, 0x30 });
            return b;
        }

        public List<byte> pedeStatusDrawer()
        {
            return new List<byte>(new byte[] { 0x10, 0x04, 0x01 });
        }

        public List<byte> pedeStatusBotaoFeed()
        {
            return new List<byte>(new byte[] { 0x10, 0x04, 0x02 });
        }
        public List<byte> pedeStatusPapelTampa()
        {
            return new List<byte>(new byte[] { 0x10, 0x04, 0x04 });
        }
        public List<byte> pedeStatusNivelPapel()
        {
            return new List<byte>(new byte[] { 0x1d, 0x72, 0x01 });
        }

        public bool drawerOn(byte status)
        {
            return  (status & 0x17) != 0x17;
        }
        public bool botaoFeedPressed(byte status)
        {
            return (status & 0x1f) == 0x1a;
        }
        public bool papelTampaOK(byte status)
        {
            return (status & 0x73) != 0x72;
        }
        public bool nivelPapeOK(byte status)
        {
            return (status & 0x1c) != 0x0c;
        }

    }



}
